// View and suggest online Tasks
setInfos(6, "subcontrol_control", "Script for controlling slaves using subcontrol script, NOT for subs",
		"Liz", "Beta", 0x222222, "en", ["maledom","femaledom","internet"]);
/*
  To be added to editor
     VARS: TIMESTART TIMENOW MCODE SCODE MOOD TASKID
	 New Commands: [LOG]text [Load]name [SAVE]name,value [IF]condition [CHEAT]Text
	 
  New commands in since ver 1.0.6
  [UPLOADWEBCAM]CAM_NO (uploads webcam pic and stores ref into TEMPSTR)
  [APPEND]onlinevarname,value - appends string to online string (with a ",")
  [SEND]onlinevarname,value - saves online string
  [RECEIVE]onlinevarname
  [NEXTTASK]hours - How many hours till allowed to do next task (default 6 if not using this)
  [TIMECHECK]X - should take at least X mins to get here in task  
  [GETSELECTION]You like fish?,true,false - will prompt a selection "Do you like fish" with options true and false saved to TEMPSTR
  [PUNISH]
  [SETMOOD]X - Set virtual mistresses mood to X (1 mad to 10 happy)
  [TIMEBUTTON]X,Text - Button that clicks after X seconds Time taken to press is stored in TEMPINT (or X if timedout)
  [SETSTR]X - Sets TEMPSTR to X
  [FORCETASK]X - Force sub to run task X next time (can be (TASKID+1)
  					 
  New Tag: [NOTRANDOMTASK] = dont run task by random only if forced
 
  May have something to make creating lines tasks easier... ? like RandomString?
*/

//safeEval - use instead of Eval.me to prevent security breach
def safeEval = { Comm1 ->
  def Comm2 = Comm1.replaceAll(/([\w]\s*)[\(|{]/,"\$1[")
  return Eval.me(Comm2)
}

//Setup Default Vars		
def MText = "Mistress"
if(!loadBoolean("intro.female"))
  MText = "Master"
def mcode = loadString("subcontrol_control.mistress_code")
def timenow = getTime();  
def isfemale = false
def Task_Text = ""
  
def MenuChoice = 0  
while(MenuChoice < 4) {
  MenuChoice = getSelectedValue("Welcome to review tasks (Masters and Mistresses only!)\n\nWhat would you like to do?",["Run through an online task","Run through a created task","Create a Task","Upload a created task","Exit"]);
  switch (MenuChoice) {
    case 0 : 
       // Test an online task	
         isfemale = getBoolean("What tasks do you want to look at?","Female","Male")
         def fname = "main_male" 
	     if (isfemale)
           fname = "main_female"
		 fname = "scripts/subcontrol/"+fname+".txt"  
		 
         if (!(new File(fname).exists())) {
		   show("Error: file not found "+fname)
           showButton("OK") 		   
           break
		 }
		 def f1 = new File(fname)
		 def lines = f1.readLines()
		 def List<String> TaskList = []
         def i=0;
         lines.each {
		   def Title = it.tokenize('[')[0]
		   TaskList.add(Title.tokenize(']')[1]);
	       i=i+1;
         }
         def TNo = getSelectedValue("Select a task you would like to test. All delays are reduced to 3 seconds and webcam pics not taken.",TaskList)		 
		 Task_Text = lines[TNo]
    case 1 :
	   // Test Local Tasks
       if (MenuChoice == 1) {
         isfemale = getBoolean("What tasks do you want to look at?","Female","Male")
         def fname = "tasks_male" 
	     if (isfemale)
           fname = "tasks_female"
		 fname = "scripts/subcontrol/"+fname+".txt"  
		 
         if (!(new File(fname).exists())) {
		   show("Error: file not found "+fname)
           showButton("OK") 		   
           break
		 }
		 def f1 = new File(fname)
		 def lines = f1.readLines()
		 def List<String> TaskList = []
         def i=0;
         lines.each {
		   def Title = it.tokenize('[')[0]
		   TaskList.add(Title.tokenize(']')[1]);
	       i=i+1;
         }
         def TNo = getSelectedValue("Select a task you would like to test. All delays are reduced to 3 seconds and webcam pics not taken.",TaskList)		 
		 Task_Text = lines[TNo]
	   }

def Msg = ""
def Task = Task_Text.tokenize('[')
def Command
def TEMPINT = 0
def TEMPSTR = ""
def TIMESTART = getTime();
def RUN_NEXT = true
for (i in 1..Task.size()) {
  Command = Task[i-1].tokenize(']')
  // Change keywords in data
  timenow = getTime();
  if (Command[1] != null) {
    Command[1] = Command[1].replaceAll("BOSS",MText)
    Command[1] = Command[1].replaceAll("MCODE",mcode)
//    Command[1] = Command[1].replaceAll("SCODE",scode)	
//    MOOD
    Command[1] = Command[1].replaceAll("TIMESTART",TIMESTART.toString())
    Command[1] = Command[1].replaceAll("TIMENOW",timenow.toString())
    Command[1] = Command[1].replaceAll("TEMPINT",TEMPINT.toString())
    Command[1] = Command[1].replaceAll("TEMPSTR",TEMPSTR)
    Command[1] = Command[1].replaceAll("TASKID","100") // a number for testing
	Command[1] = Command[1].replaceAll("RAND_2_",getRandom(2).toString())
	Command[1] = Command[1].replaceAll("RAND_5_",getRandom(5).toString())
  }
  if (!RUN_NEXT) {
    RUN_NEXT = true
  } else {
  switch (Command[0]) {
  
  // new commands log save load 
  // if cheat
  // new vars timenow timestart
  // Commands: [LOG]text [SAVE]name,value [IF]condition [CHEAT]Text
    case "TIMECHECK" : show("Check that not less than "+Command[1]+" min since task started")
	               showButton("OK") 
		           break
    case "NEXTTASK" : show("Set time till next task in hours:"+Command[1])
	               showButton("OK") 
		           break
    case "LOG":  show("Write to sub log:"+Command[1])
	               showButton("OK") 
		           break
	case "FORCETASK": // Force a sub to do this task next - handy for a linked tasks
	               show("Force task: "+safeEval(Command[1]) )
				   wait(3)
	             break
    case "IF": RUN_NEXT = (safeEval(Command[1])) // Run next command?
		           break
    case "PUNISH":  show("Force sub to do a punishment")
	               showButton("OK") 
		           break
	case "CHEAT":  show("FLAG UP CHEATING:"+Command[1])
	               showButton("OK") 
		           break
    case "UPLOADWEBCAM":  show("Upload webcam pic "+Command[1])
	               showButton("OK") 
		           break				   
    case "APPEND":  show("APPEND to server string "+Command[1])
	               showButton("OK") 
		           break					   
    case "SEND":  show("Send to server string "+Command[1])
	               showButton("OK") 
		           break
    case "RECEIVE": TEMPSTR = receiveString(Command[1]) // receive from server stored into TEMPSTR
			       if (TEMPSTR == null) TEMPSTR = ""
		           break					   
    case "LOAD": TEMPSTR = loadString(Command[1])
	             if (TEMPSTR == null) TEMPSTR = ""
	             break				   
    case "SAVE":   def List<String> rlist = Command[1].split(',')
	 			   save(rlist[0], rlist[1])
		           break	
    case "GETSTR": TEMPSTR = getString(Command[1],"") // Get a string.. stored into TEMPSTR
                   break
    case "TITLE":  show("Title = "+Command[1])
	               showButton("OK") 
		           break
    case "CHASTITY":  showButton("Set chastity to : "+Command[1]+" Days")
		           break				   
    case "NOCUM":  showButton("Set no cumming to : "+Command[1]+" Days")
		           break				   
    case "R_FETISH":  showButton("Require fetish: "+Command[1])
		           break			   
    case "R_STATUS":  showButton("Require status: "+Command[1])
		           break			   
    case "R_TOY":  showButton("Require toy: "+Command[1])
		           break			   
    case "BUTTON": showButton(Command[1])
		           break
	case "GETINT": TEMPINT = getInteger(Command[1],0) // Get a number.. stored into TEMPINT
	               break
	case "SETINT": TEMPINT = safeEval(Command[1]) // Set TEMPINT
	               break
	case "SETSTR": TEMPSTR = Command[1]
	               break
    case "TIMEBUTTON": def List<String> rlist = Command[1].split(',') 
	               def starttime = getTime()
				   showButton(rlist[1],3)
				   TEMPINT = getTime()-starttime
		           break
	case "IMAGE":  // only download if not there
	               def temppic = null
				   if (new File("images/received/"+Command[1]+".jpeg").exists())
				     temppic = "received/"+Command[1]+".jpeg"
				   else	
				     temppic = receiveImage(Command[1])
			       setImage(temppic)
	               break
	case "RNDIMAGE":  // Split and do random
	               def List<String> rlist = Command[1].split(',')
				   def rno = getRandom(rlist.size())
	               def temppic = null
				   if (new File("images/received/"+rlist[rno]).exists())
				     temppic = "received/"+rlist[rno]
				   else	
				     temppic = receiveImage(rlist[rno])
			       setImage(temppic)
	               break
	case "GETSELECTION": // Get a Selection.. stored into TEMPSTR e.g. [GETSELECTION]You like fish,true,false
	               def List<String> rlist = Command[1].split(',')
				   def prompt = rlist[0]
				   rlist.remove(0)
				   def selected = getSelectedValue(prompt,rlist)
				   TEMPSTR = rlist[selected]
	               break
    case "RSOUND": def List<String> rlist = Command[1].split(',') // [RSOUND]bell.wav,5,2 = repeat 5 times with 2 sec delay
				   for (j in 1..rlist[1].toInteger()) {
				     playSound(rlist[0])
					 wait(rlist[2].toInteger())
				   }
		           break				   
    case "SOUND":  playSound(Command[1])
		           break				   
    case "TEXT":   show(Command[1])
		           break
    case "WAIT":   // wait(Command[1]);	
                   wait(3);	// Just 3 to test
		           break				   
    case "WEBCAM": show("Webcam take pic "+Command[1])
                   wait(3);	
		           break
			   
				   // Should have a catch all to flag errors?				   
  }
  Msg += "Command = "+Command[0]+" Data = "+Command[1]+"\n" 
  }
}
showButton("Task run-through complete")

show("Task = \n"+Msg)
wait(1)
showButton("OK")
			 
// End of Test Task			 
			 break
    case 2 : 
// Create a new task - Should have checks.. using 3 webcam shots etc...
             // What sex is the task have both?
             def fname = "tasks_male" 
			 if (getBoolean("Create Task\n\nWhat list would you like to create a task for?","Female","Male"))
               fname = "tasks_female"
			 fname = "scripts/subcontrol/"+fname+".txt"  
			   
             def TaskName = getString("Please enter a name for your new task (dont use a comma in the name)","New Task")
			 // just in someone cant read! swap comma as will fuck everything up
			 TaskName = TaskName.replaceAll(",",".")
			 
			 Task_Text = "[TITLE]"+TaskName
			 // should ask about what moods can run task in here (no mood = all)
			 // Add requirements - should now work with new extra fetish selections!
			 def s_values = [false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false ]
             s_values = getBooleans("Any status or pref required at start of task?", ["cancum","in chastity","no chastity","extreme pain","Anal","Bondage","Cock and Ball Torture","Performing chores","Cum play","Exhibition","Outdoors","Pain - anything that leaves a mark","Public","Roleplay","Scat - Faeces play","Spanking","Watersports - Urine play","Shaving", "Forced task - this task can not be selected by random" ], s_values);
			 if (s_values[0])
			   Task_Text += "[R_STATUS]cancum"
			 if (s_values[1])
			   Task_Text += "[R_STATUS]chastity"
			 if (s_values[2])
			   Task_Text += "[R_STATUS]nochastity"
			 if (s_values[3])
			   Task_Text += "[R_FETISH]extremepain"
			 if (s_values[4])
			   Task_Text += "[R_FETISH]anal"			   
			 if (s_values[5])
			   Task_Text += "[R_FETISH]bondage"			   
			 if (s_values[6])
			   Task_Text += "[R_FETISH]cbt"			   
			 if (s_values[7])
			   Task_Text += "[R_FETISH]chores"			   
			 if (s_values[8]) 
			   Task_Text += "[R_FETISH]cum"			   
			 if (s_values[9])
			   Task_Text += "[R_FETISH]exhibition"			   
			 if (s_values[10])
			   Task_Text += "[R_FETISH]outdoors"			   
			 if (s_values[11])
			   Task_Text += "[R_FETISH]pain"			   
			 if (s_values[12])
			   Task_Text += "[R_FETISH]public"			   
			 if (s_values[13])
			   Task_Text += "[R_FETISH]roleplay"			   
			 if (s_values[14])
			   Task_Text += "[R_FETISH]scat"			   
			 if (s_values[15])
			   Task_Text += "[R_FETISH]spanking"			   
			 if (s_values[16])
			   Task_Text += "[R_FETISH]watersports"
			 if (s_values[17])
			   Task_Text += "[R_FETISH]shaving"
			 if (s_values[18])
			   Task_Text += "[NOTRANDOMTASK]"	
			   
			 // What Toys are needed?
def items = ["ankle_cuffs", "ballgag", "ben_wa_balls", "blindfold", "buttplug", "camera", 
	"candle", "chastity_belt", "cigarette", "clothespins", "cockring", "crop", 
	"doll", "diaper", "dildo", "dog_collar", "enema_kit", "enema_bulb", "estim", "handcuffs", "heat_rub", 
    "hood", "husband", "ice_tray", "inflatable_buttplug",  
    "nipple_clamps", "lube", "paddle", "plants", "rubber_bands", 
    "ring_gag", "rope", "shrinkwrap", "spreader_bar", "tampon",
    "vibrating_buttplug", "vibrating_dildo", "vibrator", "wife", "whip","costume"];
def names = ["ankle cuffs", "ballgag", "ben wa balls", "blindfold", "buttplug", "camera", 
	"candle", "chastity belt", "cigarette", "clothespins", "cock ring/vibrating ring", "crop / cane", 
	"doll", "diaper", "dildo", "dog collar", "enema kit", "enema bulb", "estim (electric stimulation devices)", 
	"handcuffs", "heat rub (IcyHot, Tiger Balm...)",
    "hood", "husband (or male friend)", "ice tray", "inflatable buttplug", 
    "nipple clamps", "lube", "paddle", "plants (various branchs, leaves...)", "rubber bands", 
    "ring gag", "rope", "shrinkwrap", "spreader bar", "tampon",
    "vibrating buttplug", "vibrating dildo", "vibrator", "wife (or female friend)", "whip","Costume"];
def values = []
items.each {
	values.add(false);
}
values = getBooleans("What toys are required? - try to keep to a min", names, values);
if(values != null) {
  def i=0;
  items.each {
    if (values[i])
	  Task_Text += "[R_TOY]"+it
	i=i+1;
  }
}
             // Main commands
			 def CChoice = -1
			 def WebcamNo = 1
             while(CChoice != 0) {
			 
			 // need a better way to do this do we have option for custom command with hints?
             //   add new commands  UPLOADWEBCAM, APPEND, SEND, RECEIVE but getting unmanageable! 
			 
               CChoice = getSelectedValue("Exit or Add another command?",["Exit","Button","Set chastity","Set nocum","Ask for number","Image","Sound","Text","Wait","Webcam","Repeating sound","Random Image","LOG","IF","CHEAT","LOAD","SAVE","GETSTR","NEXTTASK","TIMECHECK"]);
               switch (CChoice) {
                 case 1 :  // BUTTON
	                       Task_Text += "[BUTTON]"+getString("Enter text for button ('BOSS' get swapped to Mistress or Master as needed)","OK BOSS")
						   break
                 case 2 :  // chastity
	                       Task_Text += "[CHASTITY]"+getInteger("Enter how many days to set chastity (or 0 to clear)",2)
						   break						   
                 case 3 :  // No cum
	                       Task_Text += "[NOCUM]"+getInteger("Enter how many days till sub get to cum (or 0 to clear)",2)
						   break						   
                 case 4 :  // GETINT
	                       Task_Text += "[GETINT]"+getString("Enter the text to prompt for a number (will be saved to the keyword TEMPINT, you can use this at any point from now on)","How old are you?")
						   break
                 case 5 :  // IMAGE
                           def myfilename = getFile("Please choose your picture")  
                           setImage(myfilename)
                           if (myfilename != null) {
						     def myfilecode = sendImage(myfilename)
                             if(myfilecode==null) {
	                           show("There was a problem, uploading image")
	                           wait(3)
                             } else {
				               Task_Text += "[IMAGE]"+myfilecode
                             }		
				           }
						   break
                 case 6 :  // SOUND
	                       Task_Text += "[SOUND]"+getString("Enter the sound file to use:","tom.wav")
						   break
  			     case 7 :  // TEXT
	                       Task_Text += "[TEXT]"+getString("Enter the text ('BOSS' get swapped to Mistress or Master as needed)","Hello slave")
						   break
                 case 8 :  // Wait
	                       Task_Text += "[WAIT]"+getInteger("Enter time in seconds to wait",3)
						   break						   
                 case 9 :  // Webcam
						   if (WebcamNo <= 3) {
                             Task_Text += "[WEBCAM]"+WebcamNo
                             show("Webcam "+WebcamNo+" added (Need 3)")
                             showButton("OK")							 
						     WebcamNo++
                           } else {
                             Task_Text += "[WEBCAM]3"
                             show("Webcam added (Max. exceeded overwriting 3)")
                             showButton("OK")							 
                           }						   
						   break						   
                 case 10 : // RSOUND // [RSOUND]bell.wav,5,2 = repeat 5 times with 2 sec delay	
	                       Task_Text += "[RSOUND]"+getString("Enter the sound file to use:","tom.wav")+","+getInteger("How many times do you want to play the sound",10)+","+getInteger("Enter a time in seconds between plays",3)
						   break
                 case 11 :  // RNDIMAGE - randomly displays a pic from uploaded images
                           def myfilename = getFile("Please choose your 1st picture to be randomly selected")  
                           setImage(myfilename)
                           if (myfilename != null) {
						     def myfilecode = sendImage(myfilename)
                             if(myfilecode==null) {
	                           show("There was a problem, uploading image")
	                           wait(3)
                             } else {
				               Task_Text += "[RNDIMAGE]"+myfilecode
                             }
				           }
						   while (myfilename != null) {
						     myfilename = getFile("Please choose another picture to be randomly selected, or cancel when done")
                             setImage(myfilename)
                             if (myfilename != null) {
						       def myfilecode = sendImage(myfilename)
                               if(myfilecode==null) {
	                             show("There was a problem, uploading image")
	                             wait(3)
                               } else {
				                 Task_Text += ","+myfilecode
                               }
				             }
						   }
						   break
  			     case 12:  // LOG
	                       Task_Text += "[LOG]"+getString("Enter text to write to log file","")
						   break
  			     case 13:  // IF
	                       Task_Text += "[IF]"+getString("Enter condition","(TEMPINT == 2)")
						   break
  			     case 14:  // CHEAT
	                       Task_Text += "[CHEAT]"+getString("Enter text to explain how they cheated","")
						   break
  			     case 15:  // LOAD
	                       Task_Text += "[LOAD]"+getString("what local value do you want to load into TEMPSTR","subcontrol.task.value")
						   break
  			     case 16:  // SAVE
	                       Task_Text += "[SAVE]"+getString("what local value do you want to save to","subcontrol.task.value")+","+getString("What value do you want to save","TEMPSTR")
						   break
                 case 17 :  // GETSTR
	                       Task_Text += "[GETSTR]"+getString("Enter the text to prompt for a string (will be saved to the keyword TEMPSTR, you can use this at any point from now on)","What is your name?")
						   break
                 case 18 :  // NEXTTASK
	                       Task_Text += "[NEXTTASK]"+getString("Enter how many hours till sub allowed to run next task (can use TEMPSTR or TEMPINT)","6")
						   break
                 case 19 :  // TIMECHECK
	                       Task_Text += "[TIMECHECK]"+getString("Enter how many minutes that it should take for a sub to get to this point in the task (can use TEMPSTR or TEMPINT)","10")
						   break
			   }
			 } 
			 
			 // Append Task to local file
			 def f1 = new File(fname)
             f1 << Task_Text+"\n"

             show("New task added to file: "+fname+".\nYou can edit this text file or uploaded it directly to the suggested list, tasks may take upto a week to be checked before adding.")
             showButton("OK")				 
			 break
    case 3 : 
// Upload created task
             isfemale = getBoolean("What task do you want to upload?","Female","Male")
             def fname = "tasks_male" 
	         if (isfemale)
               fname = "tasks_female"
		     fname = "scripts/subcontrol/"+fname+".txt"
             if (!(new File(fname).exists())) {
		       show("Error: file not found "+fname)
               showButton("OK") 		   
               break
		     }
		     def f1 = new File(fname)
		     def lines = f1.readLines()
		     def List<String> TaskList = []
             def i=0;
             lines.each {
		       def Title = it.tokenize('[')[0]
		       TaskList.add(Title.tokenize(']')[1]);
	           i=i+1;
             }
             def TNo = getSelectedValue("Select a task you would like to upload to the suggested list",TaskList)		 
		     Task_Text = lines[TNo]
			 
			 if (!(Task_Text.contains("[WEBCAM]3"))) {
		       show("Error: Task does not have 3 Webcam requests")
               showButton("OK") 		   
               break
			 }

			 def List<String> STaskList = []
             if (isfemale) {
			   def TaskNames = receiveString("subcontrol.STask_Names_Female")
			   if (TaskNames == null) TaskNames = ""
			   if (TaskNames == "")
			     TaskNames = TaskList[TNo]
			   STaskList = TaskNames.split(',')
			   // Save to suggested tasks
			   //show("Task Names: "+TaskNames+" (new = "+(STaskList.size())+")\n"+Task_Text)
			   send("subcontrol.STask_Names_Female",TaskNames)
			   send("subcontrol.STask_Female_"+(STaskList.size()-1),Task_Text+"[CREATOR]"+mcode)
			 } else {
			   def TaskNames = receiveString("subcontrol.STask_Names_Male")
			   if (TaskNames == null) TaskNames = ""
			   if (TaskNames == "")
			     TaskNames = TaskList[TNo]
               else
			     TaskNames += ","+TaskList[TNo]
			   STaskList = TaskNames.split(',')
			   // Save to suggested tasks
			   //show("Task Names: "+TaskNames+" (new = "+(STaskList.size())+")\n"+Task_Text)
			   send("subcontrol.STask_Names_Male",TaskNames)
			   send("subcontrol.STask_Male_"+(STaskList.size()-1),Task_Text+"[CREATOR]"+mcode)
			 }
			 show("New suggested task "+STaskList.size()+" added: "+STaskList[TNo]+"\n"+Task_Text)
             showButton("OK")
			 break	 
  }
}  
  
wait(1)
return "subcontrol_control"

/*
 * Resources
 */
